BASE:E( "** Script **")
local Mission = {}

Mission.pilot = 'Enfield 1-1'
Mission.EWR_UnitName = "EWR"
Mission.EWR = GROUP:FindByName(Mission.EWR_UnitName):SetAIOnOff(false)
Mission.Engineer = GROUP:FindByName("Engineer")
Mission.CampEinLL = 'N 35 21.56 E 036 24.06'
Mission.CampEinMGRS = '37 S BV 63954 16687'
--Mission.Cargo = SET_CARGO:New():FilterPrefixes('Engineer'):FilterStart()
Mission.EngineerCargo = CARGO_GROUP:New( Mission.Engineer, "Engineer", "Engineer", 14 )

Mission.SafeZoneAlert = false
Mission.EngineerPickup = false
Mission.EngineerContructionDropOff = false
Mission.EWR_Activated = false

--Zones
Mission.CapeTownSafeArea = ZONE:New('CapeTownArea')
Mission.CapeTownLZ = ZONE:New('CapeTown')
Mission.CampEinArea = ZONE:New('CampEinArea')
Mission.CampEinLZ = ZONE:New('CampEin')
Mission.EWRSite = ZONE:New('EWR Construction Site')
Mission.EWRSiteArea = ZONE:New('EWR Site Area')

--Radio Beacons
Mission.CapeTownBeacon = UNIT:FindByName('CapeTownBeacon'):GetBeacon()
Mission.CapeTownBeacon:RadioBeacon("beacon.ogg", 43.20, radio.modulation.FM, 100, 10800)
Mission.EWRBeacon = UNIT:FindByName('EWR Beacon'):GetBeacon()
Mission.EWRBeacon:RadioBeacon("beacon.ogg", 41.40, radio.modulation.FM, 100, 10800)

Mission.Camp_Ein_LZ_Smoke = false
Mission.CampEinSmokeSch = SCHEDULER:New( nil, function() 
if GROUP:FindByName(Mission.pilot):IsInZone(Mission.CampEinArea) and Mission.Camp_Ein_LZ_Smoke == false then
   Mission.Camp_Ein_LZ_Smoke = true
   USERSOUND:New( "chirp.ogg" ):ToAll()
   MESSAGE:New('Enfield 1-1 we have you on radar - you are 2 miles out - poping orange smoke.',10,"Camp Ein"):ToAll()
   GROUP:FindByName('Camp Ein Smoke'):SmokeOrange()
   Mission.CampEinSmokeSch:Stop()
  end 
end, {}, 300,2)

Mission.EWR_Site_Flare = false
Mission.EWR_Site_Flare_Sch = SCHEDULER:New( nil, function() 
if GROUP:FindByName(Mission.pilot):IsInZone(Mission.EWRSiteArea) and Mission.EWR_Site_Flare == false then
   Mission.radioscratch = true
   USERSOUND:New( "chirp.ogg" ):ToAll()
   MESSAGE:New('Check out the flares - that must be our construction site.',8,"Co Pilot"):ToAll()
   UNIT:FindByName('EWR'):FlareRed()
    SCHEDULER:New( nil, 
    function()
      UNIT:FindByName('EWR'):FlareRed()
    end, {}, 3,3,0,12)
   
   Mission.EWR_Site_Flare_Sch:Stop()
  end 
end, {}, 300,2)

--EVENT Handlers
Mission.EventHandler = EVENTHANDLER:New()
Mission.EventHandler:HandleEvent(EVENTS.Birth)
Mission.EventHandler:HandleEvent(EVENTS.Takeoff)
Mission.EventHandler:HandleEvent(EVENTS.Land)
Mission.EventHandler:HandleEvent(EVENTS.PilotDead)

--- @param Core.Event#EVENT self
-- @param Core.Event#EVENTDATA EventData
-- 
function Mission.EventHandler:OnEventBirth( EventData )
  local PlayerUnit = EventData.IniUnit
  local PlayerGroup = EventData.IniGroup
  
  if PlayerGroup:GetName() == Mission.pilot then
    SCHEDULER:New( nil, function() 
      USERSOUND:New( 'TheFraternityIntro.ogg' ):ToAll()
      MESSAGE:New('Welcome to The Fraternity...',10):ToAll()
    end, {}, 3)
  end
  
  
end
  
--- @param Core.Event#EVENT self
-- @param Core.Event#EVENTDATA EventData
-- 
function Mission.EventHandler:OnEventTakeoff( EventData )
  local PlayerUnit = EventData.IniUnit
  local PlayerGroup = EventData.IniGroup
 
  Mission.safeZoneAlert = SCHEDULER:New( nil, function() 
    if GROUP:FindByName(Mission.pilot):IsInZone(Mission.CapeTownSafeArea) == false and Mission.SafeZoneAlert == false then
      Mission.SafeZoneAlert = true
      USERSOUND:New( "chirp.ogg" ):ToAll()
      MESSAGE:New('You are entering into enemy territory',8,'HQ'):ToAll()
      Mission.safeZoneAlert:Stop()
    end
  end, {}, 15,5)
  
end


--- @param Core.Event#EVENT self
-- @param Core.Event#EVENTDATA EventData
-- 
function Mission.EventHandler:OnEventLand( EventData )
  local PlayerUnit = EventData.IniUnit
  local PlayerGroup = EventData.IniGroup
  
  --landing @ Camp Ein
  if GROUP:FindByName(Mission.pilot):IsInZone(Mission.CampEinLZ) and Mission.EngineerPickup == false then
    Mission.EngineerPickup = true
      SCHEDULER:New( nil, 
        function()
          USERSOUND:New( 'chirp.ogg' ):ToAll()
          MESSAGE:New('Welcome Enfield, Engineer still getting his supplies together and will board momentarily.',10,'Camp Ein'):ToAll()

          SCHEDULER:New( nil, 
            function()
              USERSOUND:New( 'radioscratch.ogg' ):ToAll()
              MESSAGE:New("I have my equiptment - coming aboard...",6,'Engineer'):ToAll()
              Mission.EngineerCargo:__Board(4, GROUP:FindByName(Mission.pilot), 14 )
            end, {}, math.random(10,35))
          
        end, {}, 5)
  end
  
  --landing @ EWR Contruction Site
  if GROUP:FindByName(Mission.pilot):IsInZone(Mission.EWRSite) and Mission.EngineerContructionDropOff == false then
    Mission.EngineerContructionDropOff = true
    
    SCHEDULER:New( nil, 
      function()
        USERSOUND:New( 'radioscratch.ogg' ):ToAll()
        MESSAGE:New("Wait for me here, shouldn't take but a few minutes to enter my security codes.",10,'Engineer'):ToAll()
        Mission.EngineerCargo:__UnBoard(2, UNIT:FindByName('EWR Controller'):GetPointVec2())
        
          SCHEDULER:New( nil, 
            function()
              USERSOUND:New( 'radioscratch.ogg' ):ToAll()
              MESSAGE:New("EWR has been activated, that didn't take too long. Coming aboard...",10,'Engineer'):ToAll()
              Mission.EWR:SetAIOnOff(true)
              Mission.EWR_Activated = true
              Mission.EngineerCargo:__Board(4, GROUP:FindByName(Mission.pilot), 14 )
            end, {}, 90)
            
      end, {},4)
  end
  
  --landing @ Cape Town (Home)
  if GROUP:FindByName(Mission.pilot):IsInZone(Mission.CapeTownLZ) and Mission.EWR_Activated == true then
    --Mission Successful
    SCHEDULER:New( nil, 
      function()
        USERSOUND:New( "chirp.ogg" ):ToAll()
        MESSAGE:New('Damn good job! EWR has been activated. Mission successful.',15,'HQ'):ToAll()
        Mission.EngineerCargo:__UnBoard(2, UNIT:FindByName('CapeTownBeacon'):GetPointVec2())
      end, {}, 4)
  end
  
end
--- @param Core.Event#EVENT self
-- @param Core.Event#EVENTDATA EventData
-- 
function Mission.EventHandler:OnEventPilotDead( EventData )
  local PlayerUnit = EventData.IniUnit
  local PlayerGroup = EventData.IniGroup
  
end